config/routes.rb
Rails.application.routes.draw do
  scope '/api', format: :json do
    scope '/v1' do
      resources :companies do
        resources :offices
        resources :employees
        resources :projects
      end
    end
  end
  defaults format: :html do
    root 'home#index'
    get 'home/index'
    get '*path', to: 'home#index'
  end
end

app/models/project.rb
class Project < ApplicationRecord
  belongs_to :company
  has_many :employee_projects, dependent: :destroy
  has_many :employees, through: :employee_projects

  accepts_nested_attributes_for :employee_projects, allow_destroy: true

  validates :name, presence: true, length: { maximum: 100 }

  def employee_projects_or_build
    self.company.employees.each do |employee|
      employee_project = employee.employee_projects.find_by(project: self)
      if employee_project.present?
        self.employee_projects << employee_project
      else
        self.employee_projects.build(employee: employee)
      end
    end
    return self
  end

  def employee_projects_or_build_by_attributes(employee_projects_attributes)
    self.employee_projects.each do |employee_project|
      employee_project.is_checked = true
    end
    employee_projects_attributes.each do |i, employee_project|
      if employee_project[:_destroy] == '1'
        self.employee_projects.build(employee_id: employee_project[:employee_id])
      end
    end
    return self
  end
end

app/controllers/projects_controller.rb
class ProjectsController < ApplicationController
  before_action :set_project, only: [:show, :edit, :update, :destroy]
  before_action :set_company, only: [:index, :new, :create]

  # GET /projects
  def index
    @projects = @company.projects
  end

  # GET /projects/1
  def show
  end

  # GET /projects/new
  def new
    @project = @company.projects.new
    @project.employee_projects_or_build
  end

  # GET /projects/1/edit
  def edit
    @project.employee_projects_or_build
  end

  # POST /projects
  def create
    @project = @company.projects.new(project_params)
    if @project.save
      redirect_to company_project_url(@project.company, @project), notice: t('notice.created')
    else
      @project.employee_projects_or_build_by_attributes(project_params[:employee_projects_attributes])
      render :new
    end
  end

  # PATCH/PUT /projects/1
  def update
    if @project.update(project_params)
      redirect_to company_project_url(@project.company, @project), notice: t('notice.updated')
    else
      @project.employee_projects_or_build_by_attributes(project_params[:employee_projects_attributes])
      render :edit
    end
  end

  # DELETE /projects/1
  def destroy
    @project.destroy
    redirect_to company_projects_url, notice: t('notice.destroyed')
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_project
      @project = Company.find(params[:company_id]).projects.find(params[:id])
    end

    def set_company
      @company = Company.find(params[:company_id])
    end

    # Only allow a list of trusted parameters through.
    def project_params
      params.require(:project).permit(:company_id, :name, employee_projects_attributes: [:id, :_destroy, :project_id, :employee_id, :join_date, :leave_date])
    end
end

app/views/projects/_form.html.erb
<%= form_with(model: [company, project]) do |form| %>
  <% if project.errors.any? %>
    <div id="error_explanation">
      <h2><%= t('errors.template.header.other', model: t('activerecord.models.project'), count: project.errors.count) %></h2>

      <ul>
        <% project.errors.each do |error| %>
          <li><%= error.full_message %></li>
        <% end %>
      </ul>
    </div>
  <% end %>

  <div class="field">
    <%= form.label 'company.name' %>
    <%= company.name %>
  </div>

  <div class="field">
    <%= form.label :name %>
    <%= form.text_field :name %>
  </div>

  <div class="field">
    <%= form.label 'project.employee_projects.name' %>
  </div>
  <table>
    <thead>
      <tr>
        <th><%= t('activerecord.attributes.employee_project.is_checked') %></th>
        <th><%= t('activerecord.attributes.employee.name') %></th>
        <th><%= t('activerecord.attributes.employee_project.join_date') %></th>
        <th><%= t('activerecord.attributes.employee_project.leave_date') %></th>
      </tr>
    </thead>
    <tbody>
      <%= form.fields_for :employee_projects, @project.employee_projects do |employee_project| %>
        <tr>
          <td><%= employee_project.check_box :_destroy, { checked: employee_project.object.persisted? || employee_project.object.is_checked }, 0, 1 %></td>
          <td><%= employee_project.object.employee.name %></td>
          <td><%= employee_project.date_field :join_date %></td>
          <td><%= employee_project.date_field :leave_date %></td>
          <%= employee_project.hidden_field :employee_id %>
          <%= employee_project.hidden_field :project_id %>
        </tr>
      <% end %>
    </tbody>
  </table>

  <div class="actions">
    <%= form.submit %>
  </div>
<% end %>

app/views/projects/edit.html.erb
<% breadcrumb :edit_project, @project %>

<h1><%= t('.') %></h1>

<%= render 'form', company: @project.company, project: @project %>

<%= link_to t('show'), company_project_path(@project.company, @project) %> |
<%= link_to t('back'), company_projects_path(@project.company) %>

app/views/projects/index.html.erb
<% breadcrumb :projects, @company %>

<p id="notice"><%= notice %></p>

<h1><%= t('.') %></h1>

<table>
  <thead>
    <tr>
      <th><%= t('activerecord.attributes.company.name') %></th>
      <th><%= t('activerecord.attributes.project.name') %></th>
      <th colspan="3"></th>
    </tr>
  </thead>

  <tbody>
    <% @projects.each do |project| %>
      <tr>
        <td><%= project.company.name %></td>
        <td><%= project.name %></td>
        <td><%= link_to t('show'), company_project_path(project.company, project) %></td>
        <td><%= link_to t('edit'), edit_company_project_path(project.company, project) %></td>
        <td><%= link_to t('destroy'), company_project_path(project.company, project), method: :delete, data: { confirm: 'Are you sure?' } %></td>
      </tr>
    <% end %>
  </tbody>
</table>

<br>

<%= link_to t('projects.new'), new_company_project_path(@company) %>

app/views/projects/new.html.erb
<% breadcrumb :new_project, @project.company %>

<h1>New Project</h1>

<%= render 'form', company: @project.company, project: @project %>

<%= link_to t('back'), company_projects_path(@project.company) %>

app/views/projects/show.html.erb
<% breadcrumb :project, @project %>

<p id="notice"><%= notice %></p>

<p>
  <strong><%= t('activerecord.attributes.company.name') %>:</strong>
  <%= @project.company.name %>
</p>

<p>
  <strong><%= t('activerecord.attributes.project.name') %>:</strong>
  <%= @project.name %>
</p>

<p>
  <strong><%= t('activerecord.attributes.employee.name') %>:</strong>
  <%= @project.employees.pluck(:name).join(',') %>
</p>

<%= link_to t('edit'), edit_company_project_path(@project.company, @project) %> |
<%= link_to t('back'), company_projects_path(@project.company) %>